#include <QtGui>
#include "dedittable.h"
#include "treeview.h"


dEditTable::dEditTable(TreeView* parent, Qt::WindowFlags f)
        : QDialog((QWidget*) parent, f)
{
    open_Flag = 0;
    ui.setupUi(this);
    MdiParent = parent;

    connect(ui.pushButton1, SIGNAL(clicked()), this, SLOT(newField()));
    connect(ui.pushButton2, SIGNAL(clicked()), this, SLOT(delField()));
    connect(ui.pushButton3, SIGNAL(clicked()), this, SLOT(upField()));
    connect(ui.pushButton4, SIGNAL(clicked()), this, SLOT(dnField()));
}

dEditTable::~dEditTable()
{
}

void dEditTable::InitDialog(QModelIndex & Idx, int o_flag)
{
    tIdx = Idx;
    open_Flag = o_flag;
    item = static_cast<DomItem*>(Idx.internalPointer());
    if (open_Flag == 2) return; // New

    QDomNode node = item->node();  // Table Node
    QDomElement context = item->node().toElement();

    QString aStr = context.attribute("name", node.nodeName());
    ui.eName->setText(aStr);

//    aStr = node.nodeValue();
//    ui.eDescription->setText( aStr );

    int i, j, nCnt;
    DomItem *childItem;

    nCnt = item->node().childNodes().count();
    for (i = j = 0;i < nCnt;i++)
    {
        childItem = item->child(i);
        if (childItem->node().nodeName() == "field")  // Field
        {
            aStr = childItem->node().toElement().attribute("name", "xXx");
            ui.tableFields->addItem ( aStr );
            ui.tableFields->item(j++)->setData(RoleIdd, childItem->Idd);
        }
    }
}

void dEditTable::updateMD()
{
    QDomNode node = item->node();  // Table Node
    QDomElement context = item->node().toElement();

    QString aStr = ui.eName->text().simplified();
    if (!aStr.length()) aStr = node.nodeName();
    if (aStr != context.attribute("name", node.nodeName()))
        context.setAttribute("name", aStr); // "name"

    aStr = ui.eDescription->text().simplified();
//    if (aStr != MdiParent->getModel()->sText( context, "Description"))
//        MdiParent->getModel()->setSText( context, "Description", aStr );

}

/////////////////////////////////////////////////////////////////////////////////

void dEditTable::newField()
{
//    dEditField *EditField = new dEditField( MdiParent );
//    EditField->InitDialog(item, 2); // New Parent
//    if (EditField->exec() == QDialog::Accepted)
//    {
//        QString  aStr = EditField->getName();
//        EditField->updateMD();
//        ui.tableFields->addItem ( aStr );
//        ui.tableFields->item(ii)->setData(RoleIdd, childItem->Idd);
//        QModelIndex index = MdiParent->selectedIndexes().first();

//        MdiParent->collapse ( index );
//        MdiParent->expand (  index );
//    }
//    delete EditField;
}

void dEditTable::edtField()
{
}

void dEditTable::delField()
{
    int row = ui.tableFields->currentRow();
    ui.tableFields->takeItem ( row );
//    QModelIndex index = MdiParent->findIDD(item->Idd);
    MdiParent->getModel()->removeRows(row, 1, tIdx);
}

void dEditTable::upField()
{
    int row = ui.tableFields->currentRow();
    int cnt = ui.tableFields->count()-1;
    if (!row) return;

    // TODO ???

    MdiParent->getModel()->swapRows(row-1, row, tIdx);

    ui.tableFields->insertItem (row-1, ui.tableFields->takeItem ( row ) );
    ui.tableFields->setCurrentRow ( row-1 );

    return;
}

void dEditTable::dnField()
{
    int cnt = ui.tableFields->count()-1;
    int row = ui.tableFields->currentRow();
    if (row == cnt) return;

    // TODO ???
    MdiParent->getModel()->swapRows(row, row+1, tIdx);

    ui.tableFields->insertItem (row+1, ui.tableFields->takeItem ( row ) );
    ui.tableFields->setCurrentRow ( row+1 );

    return;
}

