#include <QtXml>

#include "domitem.h"

DomItem::DomItem(QDomNode &node, int row, DomItem *parent)
{
    domNode = node;
    // Record the item's location within its parent.
    rowNumber = row;
    parentItem = parent;

    Idd = (node.toElement().attribute("id", "0")).toInt();
}

DomItem::~DomItem()
{
    QHash<int,DomItem*>::iterator it;
    for (it = childItems.begin(); it != childItems.end(); ++it)
        delete it.value();
}

QDomNode DomItem::node() const
{
    return domNode;
}

int DomItem::row()
{
    return rowNumber;
}

DomItem *DomItem::parent()
{
    return parentItem;
}

DomItem *DomItem::child(int i)
{
    if (childItems.contains(i))
        return childItems[i];

    if (i >= 0 && i < domNode.childNodes().count()) {
        QDomNode childNode = domNode.childNodes().item(i);
        DomItem *childItem = new DomItem(childNode, i, this);
        childItems[i] = childItem;
        return childItem;
    }
    return 0;
}

/////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////

bool DomItem::insertChildren(int position)
{
    if (position < 0 || position > childItems.size())
        return false;

    return false;

    return true;
}

bool DomItem::insertChildrens(int position, int count)
{
    if (position < 0 || position > childItems.size())
        return false;

    return false;

    return true;
}

bool DomItem::removeChildren(int position)
{
   if (position < 0 || position > childItems.size())
       return false;

    DomItem *item = childItems.take(position);
    domNode.removeChild(item->domNode);
    delete item;
    childItems.clear();
    return true;
}

bool DomItem::removeChildrens(int position, int count)
{
    if (position < 0 || position + count > childItems.size())
        return false;

    DomItem *item;

    for (int i = 0;i < count;i++)
    {
        item = childItems.take(position);
        domNode.removeChild(item->domNode);
        delete item;
    }

    childItems.clear();

    return true;
}

bool DomItem::swapChildrens(int pos1, int pos2)
{
    if (pos1 < 0 || pos2 < 0 || pos1 > childItems.size() || pos2 > childItems.size())
        return false;

    DomItem *item1, *item2;
    QDomElement deitem1, deitem2, p1;

    if (pos1 < pos2)
    {
        item1 = childItems.take(pos1);
        item2 = childItems.value(pos2);
        QDomNode node = domNode.removeChild(item1->domNode);
        domNode.insertAfter(node, item2->domNode);
    }
    else
    {
        item1 = childItems.value(pos1);
        item2 = childItems.take(pos2);
        QDomNode node = domNode.removeChild(item2->domNode);
        domNode.insertAfter(node, item1->domNode);
    }

    childItems.clear();
    return true;
}

