#ifndef DOMITEM_H
#define DOMITEM_H

#include <QDomNode>
#include <QHash>
#include <QObject>

class DomItem : public QObject
{
public:
    DomItem(QDomNode &node, int row, DomItem *parent = 0);
    ~DomItem();
    DomItem *child(int i);
    DomItem *parent();
    QDomNode node() const;
    int row();
    int Idd;

    bool insertChildren(int position);
    bool removeChildren(int position);

    bool swapChildrens(int pos1, int pos2);
    bool insertChildrens(int position, int count = 1);
    bool removeChildrens(int position, int count = 1);

private:
    QDomNode domNode;
    QHash<int,DomItem*> childItems;
    DomItem *parentItem;
    int rowNumber;
};

#endif
