#include "treeview.h"
#include "dommodel.h"
#include "dedittable.h"


TreeView::TreeView(QWidget *parent) : QTreeView(parent)
{
    setWindowFlags(Qt::SubWindow);
    setAttribute(Qt::WA_DeleteOnClose);
    setSelectionMode(QAbstractItemView::SingleSelection);

    QFont fc;
    QFontInfo info(fc);
    fc.setPointSize(10);
    setFont(fc);

//    connect(document(), SIGNAL(contentsChanged()), this, SLOT(documentWasModified()));
//    model = new DomModel(QDomDocument("ananas_configuration"), this);
//    setModel(model);

    setWindowTitle(tr("DOM Model"));
    setColumnWidth ( 0, 500 );
    setColumnWidth ( 1, 500 );
    setColumnWidth ( 2, 100 );
}

TreeView::~TreeView()
{
}

void TreeView::mouseDoubleClickEvent( QMouseEvent *event )
{
    if (!selectedIndexes().isEmpty())
    {
        QModelIndex index = selectedIndexes().first();
        DomItem *item = static_cast<DomItem*>(index.internalPointer());

        if (item->node().nodeName() == "element")     // Tbl
        {
            dEditTable  EditTbl(this);
            EditTbl.InitDialog(index, 1);
            if (EditTbl.exec() == QDialog::Accepted)
                EditTbl.updateMD();
            event->accept();
            return;
        }
    }

    QAbstractItemView::mouseDoubleClickEvent(event);
}
